<?php
class ControllerExtensionModuleCategoryWall extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/categoryWall');

		$this->document->setTitle($this->language->get('module_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('module_categoryWall', $this->request->post);

			if ( isset($this->request->post['module_categoryWall_seoKeyword']) ) {
				$this->setSeoUrl($this->request->post['module_categoryWall_seoKeyword']);	
			}	

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true));
		}

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['meta_title'])) {
			$data['error_meta_title'] = $this->error['meta_title'];
		} else {
			$data['error_meta_title'] = array();
		}	
		
		if (isset($this->error['keyword'])) {
			$data['error_keyword'] = $this->error['keyword'];
		} else {
			$data['error_keyword'] = '';
		}

		if (isset($this->error['width'])) {
			$data['error_width'] = $this->error['width'];
		} else {
			$data['error_width'] = '';
		}

		if (isset($this->error['height'])) {
			$data['error_height'] = $this->error['height'];
		} else {
			$data['error_height'] = '';
		}		

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('module_title'),
			'href' => $this->url->link('extension/module/categoryWall', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['action'] = $this->url->link('extension/module/categoryWall', 'user_token=' . $this->session->data['user_token'], true);

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true);

		$this->load->model('localisation/language');

		$data['languages'] = $this->model_localisation_language->getLanguages();

		$this->load->model('setting/store');

		$data['stores'] = array();
		
		$data['stores'][] = array(
			'store_id' => 0,
			'name'     => $this->language->get('text_default')
		);
		
		$stores = $this->model_setting_store->getStores();

		foreach ($stores as $store) {
			$data['stores'][] = array(
				'store_id' => $store['store_id'],
				'name'     => $store['name']
			);
		}

		if (isset($this->request->post['module_categoryWall_status'])) {
			$data['module_categoryWall_status'] = $this->request->post['module_categoryWall_status'];
		} else {
			$data['module_categoryWall_status'] = $this->config->get('module_categoryWall_status');
		}

        $this->load->model('catalog/category');
		$allCategories = $this->model_catalog_category->getCategories(0);
		usort($allCategories, function($a, $b){
			return strcmp($a['name'], $b['name']);
		});

        if (isset($this->request->post['module_categoryWall_category'])
            && is_array($this->request->post['module_categoryWall_category'])
        ) {
            $categories = $this->request->post['module_categoryWall_category'];
        } elseif (is_array($this->config->get('module_categoryWall_category'))) {
            $categories = $this->config->get('module_categoryWall_category');
        } else {
            $categories = array();
		}

		foreach($categories as $select_cat) {
			foreach ($allCategories as $key => $cat) {
				if(in_array($cat['category_id'], $select_cat)) {
					unset($allCategories[$key]);
				}
			}
		}

		$data['categories'] = $allCategories;
		$data['selected_cat'] =  $categories;
		
		if (isset($this->request->post['module_categoryWall_product_count'])) {
			$data['module_categoryWall_product_count'] = $this->request->post['module_categoryWall_product_count'];
		} else {
			$data['module_categoryWall_product_count'] = $this->config->get('module_categoryWall_product_count');
		}

		if (isset($this->request->post['module_categoryWall_seo'])) {
			$data['module_categoryWall_seo'] = $this->request->post['module_categoryWall_seo'];
		} elseif (is_array($this->config->get('module_categoryWall_seo'))) {
			$data['module_categoryWall_seo'] = $this->config->get('module_categoryWall_seo');
		} else {
			$data['module_categoryWall_seo'] = array();
		}

		$seoKeyword = $this->getSeoUrl();
		if (isset($this->request->post['module_categoryWall_seoKeyword'])) {
			$data['module_categoryWall_seoKeyword'] = $this->request->post['module_categoryWall_seoKeyword'];
		} elseif (isset($seoKeyword)) {
			$data['module_categoryWall_seoKeyword'] = $seoKeyword;
		} else {
			$data['module_categoryWall_seoKeyword'] = array();
		}

		if (isset($this->request->post['module_categoryWall_width'])) {
			$data['width'] = $this->request->post['module_categoryWall_width'];
		} elseif ($this->config->get('module_categoryWall_width')) {
			$data['width'] = $this->config->get('module_categoryWall_width');
		} else {
			$data['width'] = 230;
		}

		if (isset($this->request->post['module_categoryWall_height'])) {
			$data['height'] = $this->request->post['module_categoryWall_height'];
		} elseif ($this->config->get('module_categoryWall_height')) {
			$data['height'] = $this->config->get('module_categoryWall_height');
		} else {
			$data['height'] = 230;
		}

		if (isset($this->request->post['module_categoryWall_qtyInRow'])) {
			$data['qtyInRow'] = $this->request->post['module_categoryWall_qtyInRow'];
		} elseif ($this->config->get('module_categoryWall_height')) {
			$data['qtyInRow'] = $this->config->get('module_categoryWall_qtyInRow');
		} else {
			$data['qtyInRow'] = 3;
		}
		
		if (isset($this->request->post['module_categoryWall_minWidth'])) {
			$data['minWidth'] = $this->request->post['module_categoryWall_minWidth'];
		} elseif ($this->config->get('module_categoryWall_minWidth')) {
			$data['minWidth'] = $this->config->get('module_categoryWall_minWidth');
		} else {
			$data['minWidth'] = 230;
		}
		
		if (isset($this->request->post['module_categoryWall_description'])) {
			$data['module_categoryWall_description'] = $this->request->post['module_categoryWall_description'];
		} elseif (is_array($this->config->get('module_categoryWall_description'))) {
			$data['module_categoryWall_description'] = $this->config->get('module_categoryWall_description');
		} else {
			$data['module_categoryWall_description'] = array();
		}		

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/categoryWall', $data));
	}


	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/module/categoryWall')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		if (isset($this->request->post['module_categoryWall_seo'])) {
			foreach ($this->request->post['module_categoryWall_seo'] as $language_id => $value) {
				if ((utf8_strlen($value['meta_title']) < 1) || (utf8_strlen($value['meta_title']) > 255)) {
					$this->error['meta_title'][$language_id] = $this->language->get('error_meta_title');
				}
			}
		}

		if (isset($this->request->post['module_categoryWall_seoKeyword'])) {

			$this->load->model('design/seo_url');
			
			foreach ($this->request->post['module_categoryWall_seoKeyword'] as $store_id => $language) {
				foreach ($language as $language_id => $keyword) {
					if (!empty($keyword)) {
						if (count(array_keys($language, $keyword)) > 1) {
							$this->error['keyword'][$store_id][$language_id] = $this->language->get('error_unique');
						}
						
						$seo_urls = $this->model_design_seo_url->getSeoUrlsByKeyword($keyword);
						
						if (!is_array($seo_urls)) break;
						foreach ($seo_urls as $seo_url) {
							if ( $seo_url['store_id'] == $store_id && $seo_url['language_id'] == $language_id && $seo_url['query'] != 'extension/module/categoryWall') {		
								$this->error['keyword'][$store_id][$language_id] = $this->language->get('error_keyword');
				
								break;
							}
						}
					}
				}
			}
		}
		
		if (!$this->request->post['module_categoryWall_width']) {
			$this->error['width'] = $this->language->get('error_width');
		}

		if (!$this->request->post['module_categoryWall_height']) {
			$this->error['height'] = $this->language->get('error_height');
		}	
		
		if ($this->error && !isset($this->error['warning'])) {
			$this->error['warning'] = $this->language->get('error_warning');
		}

		return !$this->error;
	} 

	protected function setSeoUrl($seokey) {
		$this->load->model('design/seo_url');

		$filter_data = array(
			'filter_query' => 'extension/module/categoryWall'
		);

		$results = $this->model_design_seo_url->getSeoUrls($filter_data);

		foreach ($results as $result) {
			$this->model_design_seo_url->deleteSeoUrl($result['seo_url_id']);
		}

		foreach ($seokey as $store_id => $language) {
			foreach ($language as $language_id => $keyword) {
				if (!empty($keyword)) {

					$data['store_id'] = $store_id;
					$data['language_id'] = $language_id;
					$data['query'] = 'extension/module/categoryWall';
					$data['keyword'] = $keyword;

					$this->model_design_seo_url->addSeoUrl($data);
				}
			}
		}
	}

	protected function getSeoUrl() {
		$this->load->model('design/seo_url');
		$CategoryWall = array();

		$filter_data = array(
			'filter_query' => 'extension/module/categoryWall'
		);

		$results = $this->model_design_seo_url->getSeoUrls($filter_data);

		foreach ($results as $result) {
			$CategoryWall[$result['store_id']][$result['language_id']] = $result['keyword'];
		}

		return $CategoryWall;
	}	
}